/*
 * AggiungiStradaFrame.java
 *
 * Created on 8 maggio 2008, 11.11
 */

package grafica;
import java.util.Vector;
import struttura.*;

/**
 *
 * @author  Fabio
 */
public class AggiungiStradaFrame extends javax.swing.JFrame {

    /** Creates new form AggiungiStradaFrame */
    public AggiungiStradaFrame(PrimoPassoPanel aPanel) {
        parentPanel = aPanel;
        //Prendo la lista delle strade già presenti
        if (incrocio.getListaStrade().isEmpty())
            indiceStrada = 0;
        else{
            indiceStrada = incrocio.getListaStrade().indexOf(incrocio.getListaStrade().lastElement());
            indiceStrada++;
        }
        incrocio.addStrada(indiceStrada, false, false);
        initComponents();
    }
    
    public void rePaintTable(){
       // Vector<Vector> vectorData = new Vector(5, 5);
        Vector<Corsia> corsieEntranti = new Vector(5, 5);
        Vector<Corsia> corsieUscenti = new Vector(5, 5);
        Strada temp = (Strada) incrocio.getListaStrade().elementAt(indiceStrada);
        corsieEntranti = temp.getListaCorsieEntranti();
        corsieUscenti = temp.getListaCorsieUscenti();
        boolean entranteAuto = false;
        boolean uscenteAuto = false;
        //Verifico quale delle due liste di corsie ha lunghezza maggiore e mi memorizzo il dato
        int i = corsieEntranti.size();
        if (corsieUscenti.size() > i)
            i = corsieUscenti.size();
        //Mi creo la Stringa dei nomi delle colonne
        String[] columnNames = {"Corsie Entranti", "Corsie Uscenti"};
        Object[][] rowData = new Object[i][2];
        //adesso faccio un ciclo for per costruirmi il Vector
        for (int j = 0; j<i; j++){
            String testo = null;
            String tipo = "";
            //Creo la colonna delle corsie entranti
            if (j < corsieEntranti.size()){
                Corsia aCorsia = (Corsia) corsieEntranti.elementAt(j);
                if (aCorsia != null){
                    Vector tipiTraffico = aCorsia.getTipiTraffico();
                    int length = tipiTraffico.size();
                    for (int k = 0; k<length; k++){
                        if ((Integer)tipiTraffico.elementAt(k)== TipoTraffico.AUTO)
                            entranteAuto = true;
                        tipo += TipoTraffico.getString((Integer)tipiTraffico.elementAt(k));
                    }
                    testo = (j+1) + "°" + " Corsia - " + tipo;
                }
            }
            rowData[j][0] = testo;
            //Creo la colonna delle corsie uscenti
            testo = null;
            tipo = "";
            if (j < corsieUscenti.size()){
                Corsia aCorsia = (Corsia) corsieUscenti.elementAt(j);
                if (aCorsia != null){
                    Vector tipiTraffico = aCorsia.getTipiTraffico();
                    int length = tipiTraffico.size();
                    for (int k = 0; k<length; k++){
                        if ((Integer)tipiTraffico.elementAt(k)== TipoTraffico.AUTO)
                            uscenteAuto = true;
                        if (k > 0)
                            tipo += " ";
                        tipo += TipoTraffico.getString((Integer)tipiTraffico.elementAt(k));
                    }
                    testo = (j+1) + "°" + " Corsia - " + tipo;
                }
            }
            rowData[j][1] = testo;
        }
        //Adesso tolgo la tabella e la rimetto        
        corsiaTable.setModel(new javax.swing.table.DefaultTableModel(rowData, columnNames));
        if (corsieEntranti.size()>0 && corsieUscenti.size()>0 && entranteAuto && uscenteAuto){
            //Devo controllare se la tipologia entrante e uscente è relativa all'auto
            this.inversioneCheck.setEnabled(true);
        }
        else{
            this.inversioneCheck.setSelected(false);
            this.inversioneCheck.setEnabled(false);
        }
        if (corsieEntranti.size()==0 && corsieUscenti.size()==0)
            eliminaBtn.setEnabled(false);
        else
            eliminaBtn.setEnabled(true);
        aggiungiCorsiaBtn.setEnabled(true);
        this.repaint();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        intestazioneLabel = new javax.swing.JLabel();
        attraversamentoCheck = new javax.swing.JCheckBox();
        inversioneCheck = new javax.swing.JCheckBox();
        corsiaLabel = new javax.swing.JLabel();
        listaCorsiePanel = new javax.swing.JScrollPane();
        corsiaTable = new javax.swing.JTable();
        aggiungiCorsiaBtn = new javax.swing.JButton();
        eliminaBtn = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Aggiungi Strada");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        intestazioneLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        intestazioneLabel.setText("Specifica le proprietà della strada");

        attraversamentoCheck.setText("Attraversamento pedonale");
        attraversamentoCheck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                attraversamentoCheckActionPerformed(evt);
            }
        });

        inversioneCheck.setText("Inversione ammessa");
        inversioneCheck.setEnabled(false);
        inversioneCheck.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                inversioneCheckStateChanged(evt);
            }
        });
        inversioneCheck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                inversioneCheckActionPerformed(evt);
            }
        });

        corsiaLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        corsiaLabel.setText("Lista Corsie");

        corsiaTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null}
            },
            new String [] {
                "Corsie Entranti", "Corsie Uscenti"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        corsiaTable.setEnabled(false);
        corsiaTable.setFocusable(false);
        listaCorsiePanel.setViewportView(corsiaTable);

        aggiungiCorsiaBtn.setText("Aggiungi Corsia");
        aggiungiCorsiaBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aggiungiCorsiaBtnActionPerformed(evt);
            }
        });

        eliminaBtn.setText("Elimina Corsia");
        eliminaBtn.setEnabled(false);
        eliminaBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                eliminaBtnActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(50, 50, 50)
                .add(aggiungiCorsiaBtn, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 59, Short.MAX_VALUE)
                .add(eliminaBtn, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(50, 50, 50))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                        .add(21, 21, 21)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(attraversamentoCheck)
                            .add(layout.createSequentialGroup()
                                .add(inversioneCheck)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 39, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                    .add(intestazioneLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 449, Short.MAX_VALUE))
                .add(10, 10, 10))
            .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE)
            .add(corsiaLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(10, 10, 10)
                .add(listaCorsiePanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 439, Short.MAX_VALUE)
                .add(10, 10, 10))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(intestazioneLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(attraversamentoCheck)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(inversioneCheck)
                .add(18, 18, 18)
                .add(corsiaLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(listaCorsiePanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(15, 15, 15)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(15, 15, 15)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(aggiungiCorsiaBtn)
                    .add(eliminaBtn))
                .add(21, 21, 21))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-460)/2, (screenSize.height-385)/2, 460, 385);
    }// </editor-fold>//GEN-END:initComponents

private void aggiungiCorsiaBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aggiungiCorsiaBtnActionPerformed
// TODO add your handling code here:
    aggiungiCorsiaBtn.setEnabled(false);
    AggiungiCorsiaFrame corsiaFrame = new AggiungiCorsiaFrame(indiceStrada, this);
    corsiaFrame.setVisible(true);
}//GEN-LAST:event_aggiungiCorsiaBtnActionPerformed

private void attraversamentoCheckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_attraversamentoCheckActionPerformed
// TODO add your handling code here:
    Vector<Strada> listaStrade = incrocio.getListaStrade();
    Strada strada = listaStrade.elementAt(indiceStrada);
    if (attraversamentoCheck.isSelected())
        strada.setAttraversamento(true);
    else
        strada.setAttraversamento(false);
        
}//GEN-LAST:event_attraversamentoCheckActionPerformed

private void inversioneCheckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inversioneCheckActionPerformed
// TODO add your handling code here:
    Vector<Strada> listaStrade = incrocio.getListaStrade();
    Strada strada = listaStrade.elementAt(indiceStrada);
    if (inversioneCheck.isSelected())
        strada.setInversione(true);
}//GEN-LAST:event_inversioneCheckActionPerformed

private void inversioneCheckStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_inversioneCheckStateChanged
// TODO add your handling code here:
    Vector<Strada> listaStrade = incrocio.getListaStrade();
    Strada strada = listaStrade.elementAt(indiceStrada);
    if (!inversioneCheck.isSelected())
        strada.setInversione(false);
}//GEN-LAST:event_inversioneCheckStateChanged

private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
// TODO add your handling code here:
    Vector<Strada> listaStrade = incrocio.getListaStrade();
    Strada strada = listaStrade.elementAt(indiceStrada);
    if ((strada.getListaCorsieEntranti().size() + strada.getListaCorsieUscenti().size()) == 0)
        incrocio.removeStrada(indiceStrada);
    parentPanel.repaint();
}//GEN-LAST:event_formWindowClosed

private void eliminaBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_eliminaBtnActionPerformed
// TODO add your handling code here:
    eliminaBtn.setEnabled(false);
    EliminaCorsiaFrame eliminaCorsia = new EliminaCorsiaFrame(this, indiceStrada);
    eliminaCorsia.setVisible(true);
}//GEN-LAST:event_eliminaBtnActionPerformed
 /*
    /**
    * @param args the command line arguments
    *
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AggiungiStradaFrame().setVisible(true);
            }
        });
    }
*/
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton aggiungiCorsiaBtn;
    private javax.swing.JCheckBox attraversamentoCheck;
    private javax.swing.JLabel corsiaLabel;
    private javax.swing.JTable corsiaTable;
    private javax.swing.JButton eliminaBtn;
    private javax.swing.JLabel intestazioneLabel;
    private javax.swing.JCheckBox inversioneCheck;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JScrollPane listaCorsiePanel;
    // End of variables declaration//GEN-END:variables
    private Incrocio incrocio = Incrocio.getInstance();
    private int indiceStrada;
    private PrimoPassoPanel parentPanel;
}
