/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package grafica;

import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.QuadCurve2D;

/**
 *
 * @author Marco
 */
class JCurve {
    
    private Point2D.Double point1;
    private double alpha1;
    private Point2D.Double point2;
    private double alpha2;
    private Point2D.Double center;
    private double radius;
    
    public JCurve(Point2D.Double a, double alpha, Point2D.Double b, double beta, Point2D.Double c, double r) {
        point1 = a;
        point2 = b;
        alpha1 = normalizeAngle(alpha);
        alpha2 = normalizeAngle(beta);
        center = c;
        radius = r;
    }
    
    private double normalizeAngle(double angle) {
        while (angle < 0)
            angle += 2 * Math.PI;
        while (angle >= 2 * Math.PI)
            angle -= 2 * Math.PI;
        return angle;
    }
    
    public void draw(Graphics2D g) {
        Point2D.Double curvePoint1 = new Point2D.Double();
        Point2D.Double curvePoint2 = new Point2D.Double();
        // calcolo le intersezioni con la circonferenza di riferimento
        // intersezione relativa a point1
        if (alpha1 == 0 || alpha1 == Math.PI) {
            double a = 1;
            double b = -2 * center.getX();
            double c = Math.pow(center.getX(), 2) + Math.pow((point1.getY() - center.getY()), 2) - Math.pow(radius, 2);
            double delta = Math.pow(b, 2) - 4 * a * c;
            if (delta >= 0) {
                double x1 = (-b + Math.sqrt(delta)) / (2 * a);
                double x2 = (-b - Math.sqrt(delta)) / (2 * a);
                double y = point1.getY();
                if (Point2D.distance(point1.getX(), point1.getY(), x1, y) < Point2D.distance(point1.getX(), point1.getY(), x2, y))
                    curvePoint1 = new Point2D.Double(x1, y);
                else
                    curvePoint1 = new Point2D.Double(x2, y);
            }
            else
                return;
        }
        else {
            if (alpha1 == Math.PI / 2 || alpha1 == Math.PI * 3 / 2) {
                double a = 1;
                double b = -2 * center.getY();
                double c = Math.pow(center.getY(), 2) + Math.pow((point1.getX() - center.getX()), 2) - Math.pow(radius, 2);
                double delta = Math.pow(b, 2) - 4 * a * c;
                if (delta >= 0) {
                    double y1 = (-b + Math.sqrt(delta)) / (2 * a);
                    double y2 = (-b - Math.sqrt(delta)) / (2 * a);
                    double x = point1.getX();
                    if (Point2D.distance(point1.getX(), point1.getY(), x, y1) < Point2D.distance(point1.getX(), point1.getY(), x, y2))
                        curvePoint1 = new Point2D.Double(x, y1);
                    else
                        curvePoint1 = new Point2D.Double(x, y2);
                }
                else
                    return;
            }
            else {
                double sin = Math.sin(alpha1);
                double cos = Math.cos(alpha1);
                double a = 1;
                double b = -2 * center.getX() * cos * cos - 2 * point1.getX() * sin * sin + 2 * sin * cos * point1.getY() - 2 * center.getY() * sin * cos;
                double c = Math.pow(center.getX(), 2) * cos * cos + Math.pow(point1.getX(), 2) * sin * sin + Math.pow(point1.getY(), 2) * cos * cos - 2 * sin * cos * point1.getX() * point1.getY() + 2 * center.getY() * point1.getX() * sin * cos - 2 * center.getY() * point1.getY() * cos * cos + Math.pow(center.getY() * cos, 2) - Math.pow(radius * cos, 2);
                double delta = Math.pow(b, 2) - 4 * a * c;
                if (delta >= 0) {
                    double x1 = (-b + Math.sqrt(delta)) / (2 * a);
                    double x2 = (-b - Math.sqrt(delta)) / (2 * a);
                    double y1 = (sin * x1 - point1.getX() * sin + point1.getY() * cos) / cos;
                    double y2 = (sin * x2 - point1.getX() * sin + point1.getY() * cos) / cos;
                    if (Point2D.distance(point1.getX(), point1.getY(), x1, y1) < Point2D.distance(point1.getX(), point1.getY(), x2, y2))
                        curvePoint1 = new Point2D.Double(x1, y1);
                    else
                        curvePoint1 = new Point2D.Double(x2, y2);
                }
                else
                    return;
            }
        }
        // intersezione relativa a point2
        if (alpha2 == 0 || alpha2 == Math.PI) {
            double a = 1;
            double b = -2 * center.getX();
            double c = Math.pow(center.getX(), 2) + Math.pow((point2.getY() - center.getY()), 2) - Math.pow(radius, 2);
            double delta = Math.pow(b, 2) - 4 * a * c;
            if (delta >= 0) {
                double x1 = (-b + Math.sqrt(delta)) / (2 * a);
                double x2 = (-b - Math.sqrt(delta)) / (2 * a);
                double y = point2.getY();
                if (Point2D.distance(point2.getX(), point2.getY(), x1, y) < Point2D.distance(point2.getX(), point2.getY(), x2, y))
                    curvePoint2 = new Point2D.Double(x1, y);
                else
                    curvePoint2 = new Point2D.Double(x2, y);
            }
            else
                return;
        }
        else {
            if (alpha2 == Math.PI / 2 || alpha2 == Math.PI * 3 / 2) {
                double a = 1;
                double b = -2 * center.getY();
                double c = Math.pow(center.getY(), 2) + Math.pow((point2.getX() - center.getX()), 2) - Math.pow(radius, 2);
                double delta = Math.pow(b, 2) - 4 * a * c;
                if (delta >= 0) {
                    double y1 = (-b + Math.sqrt(delta)) / (2 * a);
                    double y2 = (-b - Math.sqrt(delta)) / (2 * a);
                    double x = point2.getX();
                    if (Point2D.distance(point2.getX(), point2.getY(), x, y1) < Point2D.distance(point2.getX(), point2.getY(), x, y2))
                        curvePoint2 = new Point2D.Double(x, y1);
                    else
                        curvePoint2 = new Point2D.Double(x, y2);
                }
                else
                    return;
            }
            else {
                double sin = Math.sin(alpha2);
                double cos = Math.cos(alpha2);
                double a = 1;
                double b = -2 * center.getX() * cos * cos - 2 * point2.getX() * sin * sin + 2 * sin * cos * point2.getY() - 2 * center.getY() * sin * cos;
                double c = Math.pow(center.getX(), 2) * cos * cos + Math.pow(point2.getX(), 2) * sin * sin + Math.pow(point2.getY(), 2) * cos * cos - 2 * sin * cos * point2.getX() * point2.getY() + 2 * center.getY() * point2.getX() * sin * cos - 2 * center.getY() * point2.getY() * cos * cos + Math.pow(center.getY() * cos, 2) - Math.pow(radius * cos, 2);
                double delta = Math.pow(b, 2) - 4 * a * c;
                if (delta >= 0) {
                    double x1 = (-b + Math.sqrt(delta)) / (2 * a);
                    double x2 = (-b - Math.sqrt(delta)) / (2 * a);
                    double y1 = (sin * x1 - point2.getX() * sin + point2.getY() * cos) / cos;
                    double y2 = (sin * x2 - point2.getX() * sin + point2.getY() * cos) / cos;
                    if (Point2D.distance(point2.getX(), point2.getY(), x1, y1) < Point2D.distance(point2.getX(), point2.getY(), x2, y2))
                        curvePoint2 = new Point2D.Double(x1, y1);
                    else
                        curvePoint2 = new Point2D.Double(x2, y2);
                }
                else
                    return;
            }
        }
        double sin1 = Math.sin(alpha1);
        double cos1 = Math.cos(alpha1);
        double sin2 = Math.sin(alpha2);
        double cos2 = Math.cos(alpha2);
        double x1 = point1.getX();
        double y1 = point1.getY();
        double x2 = point2.getX();
        double y2 = point2.getY();
        double xc = (cos1 * cos2 * (y1 - y2) - sin1 * cos2 * x1 + sin2 * cos1 * x2) / (sin2 * cos1 - sin1 * cos2);
        double yc = (sin1 * sin2 * (x2 - x1) - sin1 * cos2 * y2 + sin2 * cos1 * y1) / (sin2 * cos1 - sin1 * cos2);
        Point2D.Double controlPoint = new Point2D.Double(xc, yc);
        Ellipse2D.Double circle = new Ellipse2D.Double(center.getX() - radius, center.getY() - radius, 2 * radius, 2 * radius);
        //g.draw(circle);
        g.draw(new Line2D.Double(point1, curvePoint1));
        g.draw(new Line2D.Double(point2, curvePoint2));
        //g.draw(new Line2D.Double(curvePoint1, curvePoint2));
        if (normalizeAngle(alpha1 + alpha2) == 0 || !circle.contains(xc, yc))
            g.draw(new Line2D.Double(curvePoint1, curvePoint2));
        else
            g.draw(new QuadCurve2D.Double(curvePoint1.getX(), curvePoint1.getY(), controlPoint.getX(), controlPoint.getY(), curvePoint2.getX(), curvePoint2.getY()));
            //g.draw(new QuadCurve2D.Double(curvePoint1.getX(), curvePoint1.getY(), center.getX(), center.getY(), curvePoint2.getX(), curvePoint2.getY()));
    }
    
}