/*
 * Principale.java
 *
 * Created on 6 maggio 2008, 17.15
 */

package grafica;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import motore.JavaToNuSMV;
import struttura.Incrocio;

/**
 *
 * @author  Fabio
 */
public class Principale extends javax.swing.JFrame implements Runnable {
    
    /** Creates new form Principale */
    public Principale() {
        initComponents();
        step = 1;
        PrimoPassoPanel primo = new PrimoPassoPanel(this);
        this.setContentPane(primo);
    }
    
    public void goToNextStep() {
        step++;
        (new Thread(this)).start();
    }
    
    public void goToFirstStep() {
        step = 1;
        (new Thread(this)).start();
    }
    
    public void run() {
        switch (step) {
            case 1:
                PrimoPassoPanel panel1 = new PrimoPassoPanel(this);
                this.setContentPane(panel1);
                this.setTitle("JTrafficControl - Passo 1: Creazione Incrocio");
                break;
            case 2:
                SecondoPassoPanel panel2 = new SecondoPassoPanel(this);
                this.setContentPane(panel2);
                this.setTitle("JTrafficControl - Passo 2: Definizione Flussi Vietati");
                break;
            case 3:
                TerzoPassoPanel panel3 = new TerzoPassoPanel(this);
                this.setContentPane(panel3);
                this.setTitle("JTrafficControl - Passo 3: Definizione Vincoli Temporali");
                break;
            case 4:
                QuartoPassoPanel panel4 = new QuartoPassoPanel(this);
                this.setContentPane(panel4);
                this.setTitle("JTrafficControl - Passo 4: Esecuzione NuSMV e Risultato");
                break;
            default:
                break;
        }
        this.validate();
        this.repaint();
    }
    
    private void deleteNuSMVFiles() {
        File nusmvFile = new File(".");
        String[] listaFile = nusmvFile.list();
        for (int i = 0; i < listaFile.length; i++) {
            File temp = new File (listaFile[i]);
            if (listaFile[i].endsWith(".smv"))
                temp.delete();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        nuovoItem = new javax.swing.JMenuItem();
        apriItem = new javax.swing.JMenuItem();
        salvaNomeItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        chiudiItem = new javax.swing.JMenuItem();
        aboutMenu = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JTrafficControl - Passo 1: Creazione Incrocio");
        setName("Principale"); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        fileMenu.setText("File");

        nuovoItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icone/page_new.gif"))); // NOI18N
        nuovoItem.setText("Nuovo");
        nuovoItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nuovoItemActionPerformed(evt);
            }
        });
        fileMenu.add(nuovoItem);

        apriItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icone/folder.gif"))); // NOI18N
        apriItem.setText("Apri...");
        apriItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                apriItemActionPerformed(evt);
            }
        });
        fileMenu.add(apriItem);

        salvaNomeItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icone/action_save.gif"))); // NOI18N
        salvaNomeItem.setText("Salva con nome...");
        salvaNomeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                salvaNomeItemActionPerformed(evt);
            }
        });
        fileMenu.add(salvaNomeItem);
        fileMenu.add(jSeparator1);

        chiudiItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icone/action_stop.gif"))); // NOI18N
        chiudiItem.setText("Chiudi");
        chiudiItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chiudiItemActionPerformed(evt);
            }
        });
        fileMenu.add(chiudiItem);

        menuBar.add(fileMenu);

        aboutMenu.setText("?");

        jMenuItem1.setText("Informazioni su...");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        aboutMenu.add(jMenuItem1);

        menuBar.add(aboutMenu);

        setJMenuBar(menuBar);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 899, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 550, Short.MAX_VALUE)
        );

        getAccessibleContext().setAccessibleName("");

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-900)/2, (screenSize.height-600)/2, 900, 600);
    }// </editor-fold>//GEN-END:initComponents

private void salvaNomeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_salvaNomeItemActionPerformed
// TODO add your handling code here:
    Incrocio incrocio = Incrocio.getInstance();
    JFileChooser chooser = new JFileChooser(".");
    /*Questo parte di codice è compatibile solamente con Java 1.6
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Only .inc files", "inc");
        chooser.setFileFilter(filter);
    */
    String[] inc = new String[] {"inc"};
    chooser.addChoosableFileFilter(new ExtFilter(inc,"Only .inc files"));
    chooser.setDialogType(JFileChooser.SAVE_DIALOG);
    int retVal = chooser.showSaveDialog(this);
    if (retVal == JFileChooser.APPROVE_OPTION){
        if(chooser.getSelectedFile().getAbsolutePath().indexOf(".inc") == (chooser.getSelectedFile().getAbsolutePath().length() - 4) )
            incrocio.salvaIncrocio(chooser.getSelectedFile().getAbsolutePath());
        else
            incrocio.salvaIncrocio(chooser.getSelectedFile().getAbsolutePath() + ".inc");
    }
}//GEN-LAST:event_salvaNomeItemActionPerformed

private void apriItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_apriItemActionPerformed
// TODO add your handling code here:
    this.deleteNuSMVFiles();
    JFileChooser chooser = new JFileChooser(".");
    /* Codice solamente compatibile con J2SE 6
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Only .inc files", "inc");
        chooser.setFileFilter(filter);
     */
    String[] inc = new String[] {"inc"};
    chooser.addChoosableFileFilter(new ExtFilter(inc,"Only .inc files"));    
    int retVal = chooser.showOpenDialog(this);
    Incrocio incrocio = Incrocio.getInstance();
    incrocio.removeStrade(incrocio.getListaStrade().size(), 0);
    if (retVal == JFileChooser.APPROVE_OPTION)
        Incrocio.loadIncrocio(chooser.getSelectedFile().getAbsolutePath());
    JavaToNuSMV.resetInstance();
    this.goToFirstStep();
    this.repaint();
}//GEN-LAST:event_apriItemActionPerformed

private void chiudiItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chiudiItemActionPerformed
// TODO add your handling code here:
    this.setVisible(false);
    this.dispose();
}//GEN-LAST:event_chiudiItemActionPerformed

private void nuovoItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nuovoItemActionPerformed
// TODO add your handling code here:
    this.deleteNuSMVFiles();
    Incrocio incrocio = Incrocio.getInstance();
    incrocio.removeStrade(incrocio.getListaStrade().size(), 0);
    JavaToNuSMV.resetInstance();
    this.goToFirstStep();
    this.repaint();
}//GEN-LAST:event_nuovoItemActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
    // TODO add your handling code here:
    this.deleteNuSMVFiles();
}//GEN-LAST:event_formWindowClosing

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
    // TODO add your handling code here:
    JOptionPane.showMessageDialog(null, "JTrafficControl v. 1.0 \n\nAutori:\nRaffaele Giuliano\nMarco Piva\nFabio Terella\nEmanuele Tracanna", "Informazioni JTrafficControl", JOptionPane.INFORMATION_MESSAGE);
}//GEN-LAST:event_jMenuItem1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu aboutMenu;
    private javax.swing.JMenuItem apriItem;
    private javax.swing.JMenuItem chiudiItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem nuovoItem;
    private javax.swing.JMenuItem salvaNomeItem;
    // End of variables declaration//GEN-END:variables
    private int step;
}
