/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package grafica;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.Stroke;
import java.awt.geom.AffineTransform;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import struttura.Corsia;
import struttura.Strada;
import struttura.TipoTraffico;

/**
 *
 * @author Fabio
 */
public class StradaForma {
    
    private Strada strada;
    private int numeroEntranti;
    private int numeroUscenti;
    private boolean pedonale;
    private int x;
    private int y;
    private int max;
    private int numeroStrada;
    private Disegno disegnoPanel;
    private double angle;
    
    public static final int LARGHEZZA = 40;
    public static final int LUNGHEZZA = 240;
    public static final int STRISCE = 5;
    private static final int STOP = 5;
    public static final int ALTEZZA_STRISCE = 20;
    private static final int HF_ALTEZZA_STRISCE = ALTEZZA_STRISCE / 2 + 2;
    private static final int SPAZIO_STRISCE_DIVISORE = 7;
    private static final int BASE_TRIANGOLO = LARGHEZZA / 3;
    private static final int ICON_WIDTH = LARGHEZZA * 3 / 5;
    private static final int ICON_WIDTH_DIVIETO = LARGHEZZA * 4 / 5;
    private static final String AUTO_ICON = "/icone/auto.gif";
    private static final String TRAM_ICON = "/icone/tram.gif";
    private static final String DIVIETO_INVERSIONE_ICON = "/icone/inversione.gif";
    
    public StradaForma(Strada temp, int anX, int anY, int aMax, int aStrada, JPanel aPanel, double angolo){
        strada = temp;
        numeroEntranti = strada.getListaCorsieEntranti().size();
        numeroUscenti = strada.getListaCorsieUscenti().size();
        pedonale = strada.getAttraversamento();
        x = anX;
        y = anY;
        max = aMax;
        numeroStrada = aStrada;
        disegnoPanel = (Disegno) aPanel;
        angle = angolo;
    }
    
    public void draw(Graphics2D g2){
        //Mi recupero le liste delle Corsie Entranti ed Uscenti dall'incrocio
        Vector<Corsia> listaEntranti = strada.getListaCorsieEntranti();
        Vector<Corsia> listaUscenti = strada.getListaCorsieUscenti();
        Stroke basic = new BasicStroke(2);
        g2.setStroke(basic);
        g2.setColor(Color.gray);        
        Rectangle2D.Double disegnoStrada = new Rectangle2D.Double(x, y, (numeroEntranti + numeroUscenti)* LARGHEZZA, LUNGHEZZA);
        g2.fill(disegnoStrada);
        //Devo disegnare i tratteggi
        g2.draw(disegnoStrada);
        //Scrivo il numero della strada
        g2.setColor(Color.red);
        g2.setFont(new Font("Arial", Font.BOLD, 14));
        String numeroStradaStr = numeroStrada + "";
        g2.drawString(numeroStradaStr, ( x + (numeroEntranti + numeroUscenti) * LARGHEZZA / 2 ) - numeroStradaStr.length() * 4, LUNGHEZZA + ALTEZZA_STRISCE);
        //Imposto il colore della linea
        g2.setColor(Color.white);
        //Verifico se c'è un attraversamento pedonale
        if (pedonale){
            Stroke attraversamentoPedonale = new BasicStroke(ALTEZZA_STRISCE, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0, new float[] {STRISCE}, 0);
            g2.setStroke(attraversamentoPedonale);
            Line2D.Double lineaAttraversamento = new Line2D.Double(x + 3 , y + max + HF_ALTEZZA_STRISCE, x + (numeroEntranti + numeroUscenti) * LARGHEZZA, y + max + HF_ALTEZZA_STRISCE);
            g2.draw(lineaAttraversamento);
            max = max + SPAZIO_STRISCE_DIVISORE + ALTEZZA_STRISCE;
        }
        else{
            max = max + SPAZIO_STRISCE_DIVISORE;
        }
        //disegno il divisore della strada
        if (numeroEntranti>0 && numeroUscenti>0){
            //Allora la linea va disegnata
            Stroke divisoreStroke = new BasicStroke(2);
            g2.setStroke(divisoreStroke);
            Line2D.Double linea = new Line2D.Double(x + numeroUscenti * LARGHEZZA, y + max, x + numeroUscenti * LARGHEZZA, y + LUNGHEZZA);
            g2.draw(linea);             
        }
        //Disegno la linea di Stop
        if (numeroEntranti > 0){
            Stroke stopStroke = new BasicStroke(5);
            g2.setStroke(stopStroke);
            Line2D.Double lineaStop = new Line2D.Double( x + numeroUscenti * LARGHEZZA + 2, y + max, x + (numeroUscenti + numeroEntranti) * LARGHEZZA - 2, y + max);
            g2.draw(lineaStop);
        }
        //Disegno i divisori di ogni corsia
        if (numeroUscenti > 1){ 
            g2.setColor(Color.white);
            for (int i = 0; i < numeroUscenti -1; i++){
                //Allora ci sono corsie uscenti e devo disegnare la linea tratteggiata
                Stroke dashedStroke = new BasicStroke(2, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0, new float[] {9}, 0);
                g2.setStroke(dashedStroke);
                Line2D.Double linea1 = new Line2D.Double(x+(i+1)* LARGHEZZA, y+max, x+(i+1)* LARGHEZZA, y + LUNGHEZZA);
                g2.draw(linea1);                
            }               
        }
        if (numeroUscenti > 0){
            //Visto che ci sono provo a disegnare anche i triangoli ed i numeri della corsia
            for (int i = 0; i < numeroUscenti; i++){
                Corsia temp = (Corsia)listaUscenti.elementAt(i);
                int indiceCorsia = temp.getIndice();
                if (indiceCorsia != -1){
                    g2.setColor(Color.CYAN);
                    Stroke divisoreStroke = new BasicStroke(1);
                    g2.setStroke(divisoreStroke);
                    Polygon triangolo = new Polygon();
                    triangolo.addPoint(x + numeroUscenti * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2 + BASE_TRIANGOLO / 2, y + max + 2 * STOP);
                    triangolo.addPoint(x + numeroUscenti * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2 - BASE_TRIANGOLO / 2, y + max + 2 * STOP);
                    triangolo.addPoint(x + numeroUscenti * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2, y + max + 2 * STOP + BASE_TRIANGOLO);                    
                    g2.draw(triangolo);
                    g2.fill(triangolo);
                    String indiceCorsiaStr = indiceCorsia + "";
                    g2.drawString(indiceCorsiaStr, x + numeroUscenti * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2 - indiceCorsiaStr.length() * 4, y + max + 3 * STOP + 2 * BASE_TRIANGOLO);
                    AffineTransform trasf = new AffineTransform();
                    trasf.setToRotation(angle);
                    disegnoPanel.addPuntoCorsia(indiceCorsia, new Point2D.Double(x + numeroUscenti * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2, y + max + 2 * STOP), trasf, angle);
                }
                Vector tipiTraffico = temp.getTipiTraffico();
                for (int j = 0; j < tipiTraffico.size(); j++) {
                    String icon = "";
                    switch ((Integer) tipiTraffico.get(j)) {
                        case TipoTraffico.AUTO:
                            icon = AUTO_ICON;
                            break;
                        case TipoTraffico.TRAM:
                            icon = TRAM_ICON;
                            break;
                        default:
                            break;
                    }
                    if (!icon.equals(""))
                        g2.drawImage(new ImageIcon(getClass().getResource(icon)).getImage(), x + numeroUscenti * LARGHEZZA - (i+1) * LARGHEZZA + (LARGHEZZA - ICON_WIDTH) / 2, y + max + 4 * STOP + 2 * BASE_TRIANGOLO + j * ICON_WIDTH, ICON_WIDTH, ICON_WIDTH, disegnoPanel);
                }
            }
        }
        if (numeroEntranti > 1){
            //Allora ci sono corsie entranti e devo disegnare la linea tratteggiata
            Stroke dashedStroke = new BasicStroke(2, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL, 0, new float[] {9}, 0);
            g2.setStroke(dashedStroke);
            g2.setColor(Color.white);
            for (int i = 0; i < numeroEntranti -1; i++){
                Line2D.Double linea1 = new Line2D.Double(x+(i+1+numeroUscenti)* LARGHEZZA, y+max, x+(i+1+numeroUscenti)* LARGHEZZA, y + LUNGHEZZA);
                g2.draw(linea1);
            }                
        }    
        if (numeroEntranti > 0){
            //Visto che ci sono provo a disegnare anche i triangoli ed i numeri della corsia
            for (int i = 0; i < numeroEntranti; i++){
                Corsia temp = (Corsia)listaEntranti.elementAt(i);
                int indiceCorsia = temp.getIndice();
                if (indiceCorsia != -1){
                    g2.setColor(Color.YELLOW);
                    Stroke divisoreStroke = new BasicStroke(1);
                    g2.setStroke(divisoreStroke);
                    Polygon triangolo = new Polygon();
                    triangolo.addPoint(x + (numeroUscenti + numeroEntranti) * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2 + BASE_TRIANGOLO / 2, y + max + 2 * STOP + BASE_TRIANGOLO);
                    triangolo.addPoint(x + (numeroUscenti + numeroEntranti) * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2 - BASE_TRIANGOLO / 2, y + max + 2 * STOP + BASE_TRIANGOLO);
                    triangolo.addPoint(x + (numeroUscenti + numeroEntranti) * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2, y + max + 2 * STOP);                    
                    g2.draw(triangolo);
                    g2.fill(triangolo);
                    String indiceCorsiaStr = indiceCorsia + "";
                    g2.drawString(indiceCorsiaStr, x + (numeroUscenti + numeroEntranti) * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2 - indiceCorsiaStr.length() * 4, y + max + 3 * STOP + 2 * BASE_TRIANGOLO);
                    AffineTransform trasf = new AffineTransform();
                    trasf.setToRotation(angle);
                    disegnoPanel.addPuntoCorsia(indiceCorsia, new Point2D.Double(x + (numeroUscenti + numeroEntranti) * LARGHEZZA - (i)* LARGHEZZA - LARGHEZZA / 2, y + max + 2 * STOP), trasf, angle);
                }
                Vector tipiTraffico = temp.getTipiTraffico();
                for (int j = 0; j < tipiTraffico.size(); j++) {
                    String icon = "";
                    switch ((Integer) tipiTraffico.get(j)) {
                        case TipoTraffico.AUTO:
                            icon = AUTO_ICON;
                            break;
                        case TipoTraffico.TRAM:
                            icon = TRAM_ICON;
                            break;
                        default:
                            break;
                    }
                    if (!icon.equals(""))
                        g2.drawImage(new ImageIcon(getClass().getResource(icon)).getImage(), x  + (numeroUscenti + numeroEntranti) * LARGHEZZA - (i+1) * LARGHEZZA + (LARGHEZZA - ICON_WIDTH) / 2, y + max + 4 * STOP + 2 * BASE_TRIANGOLO + j * ICON_WIDTH, ICON_WIDTH, ICON_WIDTH, disegnoPanel);
                }
            }
        }
        if (numeroEntranti > 0 && numeroUscenti > 0 && !strada.getInversione()){
             g2.drawImage(new ImageIcon(getClass().getResource(DIVIETO_INVERSIONE_ICON)).getImage(), x  + (numeroUscenti + numeroEntranti) * LARGHEZZA / 2 - (ICON_WIDTH_DIVIETO / 2), y + LUNGHEZZA - (ICON_WIDTH_DIVIETO), ICON_WIDTH_DIVIETO, ICON_WIDTH_DIVIETO, disegnoPanel);
        }
        g2.setStroke(basic);
    }

}
