/*
 * TerzoPassoPanel.java
 *
 * Created on 9 giugno 2008, 17.53
 */

package grafica;

import motore.JavaToNuSMV;
import struttura.Flusso;
import struttura.ListaFlussi;
import struttura.TipoTraffico;

/**
 *
 * @author  fabio
 */
public class TerzoPassoPanel extends javax.swing.JPanel {
    
    /** Creates new form TerzoPassoPanel */
    public TerzoPassoPanel(Principale parentFrame) {
        initComponents();
        frame = parentFrame;
        JavaToNuSMV motore = JavaToNuSMV.getInstance();
        motore.creaListaFlussi();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup = new javax.swing.ButtonGroup();
        disegnoPanel = new Disegno();
        optionPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        collisionCheck = new javax.swing.JCheckBox();
        jSeparator1 = new javax.swing.JSeparator();
        nessunoRadioBtn = new javax.swing.JRadioButton("Nessun vincolo temporale", true);
        tipoTrafficoRadioBtn = new javax.swing.JRadioButton();
        jLabel2 = new javax.swing.JLabel();
        autoRosso = new NonPiuDiDueCifre();
        autoVerde = new NonPiuDiDueCifre();
        jLabel3 = new javax.swing.JLabel();
        tramRosso = new NonPiuDiDueCifre();
        tramVerde = new NonPiuDiDueCifre();
        flussoRadioBtn = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        vincoliTextArea = new javax.swing.JTextArea();
        aggiungiBtn = new javax.swing.JButton();
        launcherBtn = new javax.swing.JButton();
        eliminaBtn = new javax.swing.JButton();
        jLabel8 = new javax.swing.JLabel();
        pedoniRosso = new NonPiuDiDueCifre();
        pedoniVerde = new NonPiuDiDueCifre();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();

        setMinimumSize(new java.awt.Dimension(900, 600));

        org.jdesktop.layout.GroupLayout disegnoPanelLayout = new org.jdesktop.layout.GroupLayout(disegnoPanel);
        disegnoPanel.setLayout(disegnoPanelLayout);
        disegnoPanelLayout.setHorizontalGroup(
            disegnoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 614, Short.MAX_VALUE)
        );
        disegnoPanelLayout.setVerticalGroup(
            disegnoPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 600, Short.MAX_VALUE)
        );

        optionPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        jLabel1.setText("Opzioni disponibili");

        collisionCheck.setText("Considera confluenze come collisioni");
        collisionCheck.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                collisionCheckActionPerformed(evt);
            }
        });

        buttonGroup.add(nessunoRadioBtn);
        nessunoRadioBtn.setText("Nessun vincolo temporale");

        buttonGroup.add(tipoTrafficoRadioBtn);
        tipoTrafficoRadioBtn.setText("Vincolo di durata per tipo di traffico");
        tipoTrafficoRadioBtn.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tipoTrafficoRadioBtnStateChanged(evt);
            }
        });
        tipoTrafficoRadioBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tipoTrafficoRadioBtnActionPerformed(evt);
            }
        });

        jLabel2.setText("Auto:");

        jLabel3.setText("Tram:");

        buttonGroup.add(flussoRadioBtn);
        flussoRadioBtn.setText("Vincolo di durata per flussi");
        flussoRadioBtn.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                flussoRadioBtnStateChanged(evt);
            }
        });
        flussoRadioBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                flussoRadioBtnActionPerformed(evt);
            }
        });

        vincoliTextArea.setColumns(10);
        vincoliTextArea.setEditable(false);
        vincoliTextArea.setRows(5);
        vincoliTextArea.setMargin(new java.awt.Insets(5, 5, 5, 5));
        vincoliTextArea.setPreferredSize(new java.awt.Dimension(100, 95));
        jScrollPane1.setViewportView(vincoliTextArea);

        aggiungiBtn.setText("Aggiungi");
        aggiungiBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aggiungiBtnActionPerformed(evt);
            }
        });

        launcherBtn.setText("Avanti >>");
        launcherBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                launcherBtnActionPerformed(evt);
            }
        });

        eliminaBtn.setText("Elimina");
        eliminaBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                eliminaBtnActionPerformed(evt);
            }
        });

        jLabel8.setText("Pedoni:");

        jLabel4.setText("max rosso");

        jLabel5.setText("min verde");

        org.jdesktop.layout.GroupLayout optionPanelLayout = new org.jdesktop.layout.GroupLayout(optionPanel);
        optionPanel.setLayout(optionPanelLayout);
        optionPanelLayout.setHorizontalGroup(
            optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                .add(org.jdesktop.layout.GroupLayout.LEADING, optionPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(nessunoRadioBtn)
                        .add(jLabel1)
                        .add(collisionCheck)
                        .add(tipoTrafficoRadioBtn)))
                .add(org.jdesktop.layout.GroupLayout.LEADING, optionPanelLayout.createSequentialGroup()
                    .add(31, 31, 31)
                    .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 243, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(optionPanelLayout.createSequentialGroup()
                            .add(aggiungiBtn, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(eliminaBtn, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, optionPanelLayout.createSequentialGroup()
                .add(37, 37, 37)
                .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel3)
                    .add(jLabel8)
                    .add(jLabel2))
                .add(20, 20, 20)
                .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(pedoniRosso, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                    .add(tramRosso, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(autoRosso, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE))
                .add(28, 28, 28)
                .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(pedoniVerde, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                    .add(autoVerde, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                    .add(tramVerde, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                    .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, optionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(launcherBtn, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, optionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 262, Short.MAX_VALUE)
                .addContainerGap())
            .add(optionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(flussoRadioBtn)
                .addContainerGap(80, Short.MAX_VALUE))
        );
        optionPanelLayout.setVerticalGroup(
            optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(optionPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(collisionCheck)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(nessunoRadioBtn)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(tipoTrafficoRadioBtn)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(optionPanelLayout.createSequentialGroup()
                        .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(2, 2, 2)
                        .add(autoVerde, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tramVerde, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(pedoniVerde, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(optionPanelLayout.createSequentialGroup()
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 17, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(2, 2, 2)
                        .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(autoRosso, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel2))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(tramRosso, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel3))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(pedoniRosso, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jLabel8))))
                .add(12, 12, 12)
                .add(flussoRadioBtn)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 204, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(optionPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(aggiungiBtn)
                    .add(eliminaBtn))
                .add(18, 18, 18)
                .add(launcherBtn)
                .addContainerGap())
        );

        autoRosso.setEditable(false);
        autoVerde.setEditable(false);
        tramRosso.setEditable(false);
        tramVerde.setEditable(false);
        aggiungiBtn.setEnabled(false);
        eliminaBtn.setEnabled(false);
        pedoniRosso.setEditable(false);
        pedoniVerde.setEditable(false);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(disegnoPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(0, 0, 0)
                .add(optionPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 286, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(0, 0, 0))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(disegnoPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .add(optionPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void collisionCheckActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_collisionCheckActionPerformed
        // TODO add your handling code here:
        JavaToNuSMV motore = JavaToNuSMV.getInstance();
        if (collisionCheck.isSelected())
            motore.setConcorrenzaStessaDestinazione(true);
        else
            motore.setConcorrenzaStessaDestinazione(false);
    }//GEN-LAST:event_collisionCheckActionPerformed

    private void tipoTrafficoRadioBtnStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_tipoTrafficoRadioBtnStateChanged
        // TODO add your handling code here:
        if(!tipoTrafficoRadioBtn.isSelected()){
            autoRosso.setEditable(false);
            autoVerde.setEditable(false);
            tramRosso.setEditable(false);
            tramVerde.setEditable(false);
            pedoniRosso.setEditable(false);
            pedoniVerde.setEditable(false);
        }
    }//GEN-LAST:event_tipoTrafficoRadioBtnStateChanged

    private void tipoTrafficoRadioBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tipoTrafficoRadioBtnActionPerformed
        // TODO add your handling code here:
        if (tipoTrafficoRadioBtn.isSelected()){
            autoRosso.setEditable(true);
            autoVerde.setEditable(true);
            tramRosso.setEditable(true);
            tramVerde.setEditable(true);
            pedoniRosso.setEditable(true);
            pedoniVerde.setEditable(true);
        }
    }//GEN-LAST:event_tipoTrafficoRadioBtnActionPerformed

    private void flussoRadioBtnStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_flussoRadioBtnStateChanged
        // TODO add your handling code here:
        if (!flussoRadioBtn.isSelected()){
            aggiungiBtn.setEnabled(false);
            eliminaBtn.setEnabled(false);
            this.repaint();
        }
    }//GEN-LAST:event_flussoRadioBtnStateChanged

    private void flussoRadioBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flussoRadioBtnActionPerformed
        // TODO add your handling code here:
        if (flussoRadioBtn.isSelected()){
            aggiungiBtn.setEnabled(true);
            eliminaBtn.setEnabled(true);
            this.repaint();
        }
    }//GEN-LAST:event_flussoRadioBtnActionPerformed

    private void aggiungiBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aggiungiBtnActionPerformed
        // TODO add your handling code here:
        aggiungiBtn.setEnabled(false);
        AggiungiVincoloFlussoFrame vincoloFrame = new AggiungiVincoloFlussoFrame(this);
        vincoloFrame.setVisible(true);
    }//GEN-LAST:event_aggiungiBtnActionPerformed

    private void launcherBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_launcherBtnActionPerformed
        // TODO add your handling code here:
        if (nessunoRadioBtn.isSelected()) {
            JavaToNuSMV motore = JavaToNuSMV.getInstance();
            ListaFlussi listaFlussi = motore.getListaFlussi();
            for (int i = 0; i < listaFlussi.size(); i++) {
                Flusso flusso = listaFlussi.getFlusso(i);
                flusso.setMaxRosso(-1);
                flusso.setMinVerde(-1);
            }
        } else
            if (tipoTrafficoRadioBtn.isSelected()) {
                JavaToNuSMV motore = JavaToNuSMV.getInstance();
                ListaFlussi listaFlussi = motore.getListaFlussi();
                for (int i = 0; i < listaFlussi.size(); i++) {
                    Flusso flusso = listaFlussi.getFlusso(i);
                    int maxRosso = -1;
                    int minVerde = -1;
                    switch (flusso.getTipoTraffico()) {
                        case TipoTraffico.AUTO:
                            if (!autoRosso.getText().equals(""))
                                maxRosso = Integer.parseInt(autoRosso.getText());
                            if (!autoVerde.getText().equals(""))
                                minVerde = Integer.parseInt(autoVerde.getText());
                            break;
                        case TipoTraffico.TRAM:
                            if (!tramRosso.getText().equals(""))
                                maxRosso = Integer.parseInt(tramRosso.getText());
                            if (!tramVerde.getText().equals(""))
                                minVerde = Integer.parseInt(tramVerde.getText());
                            break;
                        case TipoTraffico.PEDONI:
                            if (!pedoniRosso.getText().equals(""))
                                maxRosso = Integer.parseInt(pedoniRosso.getText());
                            if (!pedoniVerde.getText().equals(""))
                                minVerde = Integer.parseInt(pedoniVerde.getText());
                            break;
                        default:
                            break;
                    }
                    flusso.setMaxRosso(maxRosso);
                    flusso.setMinVerde(minVerde);
                }
            }
        frame.goToNextStep();
    }//GEN-LAST:event_launcherBtnActionPerformed

    private void eliminaBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_eliminaBtnActionPerformed
        // TODO add your handling code here:
        eliminaBtn.setEnabled(false);
        EliminaVincoloFlussoFrame eliminaFrame = new EliminaVincoloFlussoFrame(this);
        eliminaFrame.setVisible(true);
    }//GEN-LAST:event_eliminaBtnActionPerformed
    
    public String getTextArea() {
        return vincoliTextArea.getText();
    }
    
    public void setTextArea(String testo) {
        vincoliTextArea.setText(testo);
    }
    
    @Override
    public void repaint() {
        if (flussoRadioBtn != null) {
            if (flussoRadioBtn.isSelected()) {
                aggiungiBtn.setEnabled(true);
                if (this.getTextArea().equals(""))
                    eliminaBtn.setEnabled(false);
                else
                    eliminaBtn.setEnabled(true);
            }
        }
        super.repaint();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton aggiungiBtn;
    private javax.swing.JTextField autoRosso;
    private javax.swing.JTextField autoVerde;
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.JCheckBox collisionCheck;
    private javax.swing.JPanel disegnoPanel;
    private javax.swing.JButton eliminaBtn;
    private javax.swing.JRadioButton flussoRadioBtn;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton launcherBtn;
    private javax.swing.JRadioButton nessunoRadioBtn;
    private javax.swing.JPanel optionPanel;
    private javax.swing.JTextField pedoniRosso;
    private javax.swing.JTextField pedoniVerde;
    private javax.swing.JRadioButton tipoTrafficoRadioBtn;
    private javax.swing.JTextField tramRosso;
    private javax.swing.JTextField tramVerde;
    private javax.swing.JTextArea vincoliTextArea;
    // End of variables declaration//GEN-END:variables
    private Principale frame;
}
