package motore;

import grafica.QuartoPassoPanel;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Timer;
import java.util.Vector;


public class Launcher implements Runnable {
    
    private String command;
    long endDelay = 0;
    QuartoPassoPanel outputPanel;
    String descrizione;

    public Launcher(String aCommand, long seconds, QuartoPassoPanel panel, String aDescrizione) {
        command = aCommand;
        endDelay = seconds * 1000;
        outputPanel = panel;
        descrizione = aDescrizione;
    }
    
    public void run() {
        String testo = "";
        Timer endTimer = new Timer();
        LauncherManager manager = LauncherManager.getInstance();
        
        try {
            if (!descrizione.equals(""))
                outputPanel.addProgramMessage(descrizione + "\n");
            outputPanel.addProgramMessage("Eseguo: " + command + "\n");
            Runtime runtime = Runtime.getRuntime();
            Process process = runtime.exec(command);
            manager.setCurrentProcess(process);
            
            if (endDelay > 0) {
                endTimer.schedule(new KillProcess(process), endDelay);
            }
            InputStream out = process.getInputStream();
            
            InputStreamReader flusso = new InputStreamReader(out);
            BufferedReader in = new BufferedReader(flusso);
            String buffer = in.readLine();
            testo += buffer;
            while (buffer != null) {
                buffer = in.readLine();
                if (buffer != null)
                    testo += "\n" + buffer;
            }
        }
        catch (Exception e) {
        }
        
        endTimer.cancel();
        if (Parser.checkSmvString(testo)) {
            outputPanel.addProgramMessage("Risultato trovato!!!\n");
            outputPanel.setOutputAreaText(testo);
            Vector<Vector> tableContent = Parser.parse2Matrix(testo);
            outputPanel.repaintTable(tableContent);
            manager.stopExecution();
        }
        else {
            outputPanel.addProgramMessage("Risultato non trovato.\n");
        }
    }

}