package motore;

import java.util.*;

public class Parser {
	
	
	/*
	 * Metodo che prende in ingresso la stringa da parsare e costruisce la matrice con i valori per le variabili
	 * Da per scontato che sia gi stato fatto il controllo se nella stringa di ritorno di NuSMV ci sia is true o is false
	 **/
	 
	public static Vector parse2Matrix(String smvString){
		//struttura risultante che sara' un Vector di Vector
		Vector<Vector> varTable = new Vector<Vector>(20, 20);
		//splitto la stringa con separatore "-> State: 1."	
		String[] arrString = smvString.split("-> State: 1.");

		//devo saltare il primo token perche'  quello della parte iniziale dell'out
		int count=1;
		while(count < arrString.length){
			//ad ogni token ho un nuovo stato
			
			//se lo stato e' il primo costruisco tutti gli elementi del Vector di tipo VarData, altrimenti copio dalla precedente e cambio solo quelle diverse
			String actualToken = arrString[count];
			
			if(count == 1){				
				//costruisco un nuovo tokenizer con delimitatore "\n" su actualToken
				StringTokenizer auxTok = new StringTokenizer(actualToken, "\n");
				
				//anche qui devo saltare il primo token
				auxTok.nextToken();
				
				//struttura dati che conterrà le info sulle variabili dell'istanta corrente
				Vector<VarData> tempVect = new Vector<VarData>(20, 20);
				
				while(auxTok.hasMoreTokens()){
					String varToken = auxTok.nextToken().trim();
					
					if(!varToken.startsWith("->") && !(varToken.startsWith("--"))){					
						//ora ho bisogno di un tokenizer con delimitatore "="
						StringTokenizer varTok = new StringTokenizer(varToken, "=");
						
						//il primo token sara' la variabile e l'altro il valore
						VarData tempVarData = new VarData();
						tempVarData.setVarName(varTok.nextToken().trim());
						
						//devo convertire in intero il token che contiene il valore della variabile
						Integer varValue = new Integer(varTok.nextToken().trim());
						tempVarData.setVarValue(varValue);
						
						//aggiungo la struttura dati al vector dell'istante corrente
						tempVect.add(tempVarData);
					}
										
				}
				
				//aggiungo il vettore dell'istante corrente alla tabella finale
				varTable.add(tempVect);
			}
			
			//se non e' il primo copio l'elemento precedente della tabella finale
			else{
				
				Vector<VarData> lastVecVarData = (Vector)varTable.lastElement();
				Vector<VarData> cloneVecVarData = (Vector)lastVecVarData.clone();
				
				//costruisco un nuovo tokenizer con delimitatore "\n" su actualToken
				StringTokenizer auxTok = new StringTokenizer(actualToken, "\n");
				
				//anche qui devo saltare il primo token
				auxTok.nextToken();
				
				while(auxTok.hasMoreTokens()){
					String varToken = auxTok.nextToken().trim();
					
					if(!varToken.startsWith("->") && !(varToken.startsWith("--"))){	
						//ora ho bisogno di un tokenizer con delimitatore "="
						StringTokenizer varTok = new StringTokenizer(varToken, "=");
						
						//il primo token sara' la variabile e l'altro il valore
						VarData tempVarData = new VarData();
						tempVarData.setVarName(varTok.nextToken().trim());
						
						//devo convertire in intero il token che contiene il valore della variabile
						Integer varValue = new Integer(varTok.nextToken().trim());
						tempVarData.setVarValue(varValue);
						
						//devo andare a prendere l'indice dell'elemento tempVarData nel vector clonato
						int index = 0;
						boolean trovato = false;
						
						while(!trovato){
							//devo controllare ogni elemento del vettore clonato finchè non trovo quello corrispondente alla var che mi interessa
							VarData checkVarData = (VarData)cloneVecVarData.elementAt(index);
							if(checkVarData.getVarName().equals(tempVarData.getVarName())){
								trovato = true;
								//nel caso in cui ho trovato la var di interesse devo eliminare l'el dal clone e sostituirlo con tempVarData
								cloneVecVarData.removeElementAt(index);
								cloneVecVarData.insertElementAt(tempVarData, index);
							}
							else
								index++;
						}
						
					}
										
				}
				
				//aggiungo il vettore dell'istante corrente alla tabella finale
				varTable.add(cloneVecVarData);
				
			}
			
			count++;	
		}
		
		return varTable;
	}
	
	
	/*
	 * Metodo per la verifica della stringa da parsare: controlla se all'interno della stringa passata è presente lo statement "is false"
	 **/
	 
	 public static boolean checkSmvString(String smvString){
	 	boolean checkRes = false;
	 	
	 	if(smvString.contains("is false"))
	 		checkRes = true;
	 	
	 	return checkRes;
	 }
}