package struttura;

import java.util.Vector;

public class ArrayOrdinatoCircolare {

	private Vector<Integer> vettore;

	public ArrayOrdinatoCircolare() {
		vettore = new Vector<Integer>();
	}

	// metodo che aggiunge l'intero 'elem'  in 'vettore' in modo ordinato
	// es.: vettore = [2,3,6]; add(5) => vettore = [2,3,5,6]
	public void add(int elem) {
		int i;
		for (i = 0; i < vettore.size(); i++) {
			if (vettore.get(i) > elem) {
				vettore.insertElementAt(elem, i);
				break;
			}
		}
		if (i == vettore.size())
			vettore.add(elem);
	}
	
	// metodo che restituisce la dimensione di 'vettore'
	public int size() {
		return vettore.size();
	}
	
	// metodo che restituisce l'intero in posizione 'index' in 'vettore'
	public int get(int index) {
		return vettore.get(index);
	}
	
	// metodo che restituisce il sotto-vettore di 'vettore' compreso tra 'lowerValue' ed 'upperValue' modulo 'vettore.length'
	// es.: vettore = [2,3,5,6,8] ; getSubset(3, 1) => result = [8,2]
	public Vector getSubset(int lowerValue, int upperValue) {
		Vector<Integer> result = new Vector<Integer>();
		int i = 0;
		while (i < vettore.size() && vettore.get(i) <= lowerValue)
			i++;
		if (lowerValue > upperValue) {
			while (i < vettore.size()) {
				result.add(vettore.get(i));
				i++;
			}
			i = 0;
		}
		while (i < vettore.size() && vettore.get(i) < upperValue) {
			result.add(vettore.get(i));
			i++;
		}
		
		return result;
	}
	
	// metodo che aggiunge in modo ordinato a 'vettore' ogni elemento di 'aoc'
	// es.: vettore = [2,4,6,7] ; union([1,3,5,8,9])  ==>  vettore = [1,2,3,4,5,6,7,8,9]
	public void union(ArrayOrdinatoCircolare aoc) {
		for (int i = 0; i < aoc.size(); i++)
			add(aoc.get(i));
	}
	
}