package struttura;

import java.io.Serializable;
import java.util.Vector;

public class Corsia implements Serializable {

	public static final String ENTRANTE = "entrante";
	public static final String USCENTE = "uscente";
	
	private String tipo;	// la corsia può essere "entrante" (nell'incrocio) o "uscente" (dall'incrocio)
	private int indice = -1;	// è il numero della corsia
	private Vector<Integer> tipiTraffico = new Vector<Integer>();	// si usa un Vector poich� le corsie uscenti possono supportare pi� tipologie di traffico (ad esempio auto e tram)
	private Strada strada;	// è la strada cui appartiene la corsia
	
	// costruttore: imposta il tipo della corsia e la strada cui essa appartiene
	public Corsia(String aTipo, Strada aStrada) {
		tipo = aTipo;
		strada = aStrada;
	}
	
	
	// METODI DI SET DELLE PROPRIETA'
	
	public void setTipo(String aTipo) {
		tipo = aTipo;
	}
	
	public void setIndice(int anIndice) {
		indice = anIndice;
	}
	
	
	// METODI DI GET DELLE PROPRIETA'
	
	public String getTipo() {
		return tipo;
	}
	
	public Strada getStrada() {
		return strada;
	}
	
	public int getIndice() {
		return indice;
	}
	
	public Vector getTipiTraffico() {
		return tipiTraffico;
	}
	
	
	// METODI DI ADD
	
	// metodo che aggiunge una tipologia di traffico alla corsia
	public void addTipoTraffico(int aTipoTraffico) {
		tipiTraffico.add(aTipoTraffico);
	}
	
}