package struttura;

import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import java.util.Vector;

public class Incrocio implements Serializable {
	
	private Vector<Strada> listaStrade;
	private static Incrocio instance = null;
	
	private Incrocio(int numStrade) {
		listaStrade = new Vector<Strada>(numStrade, numStrade);
	}
	
	private Incrocio() {
		listaStrade = new Vector<Strada>();
	}
	
	public static Incrocio getInstance(int numStrade) {
		if (instance==null)
			instance = new Incrocio(numStrade);
		return instance;
	}
	
	public static Incrocio getInstance() {
		if (instance == null)
			instance = new Incrocio();
		return instance;
	}
	
	public Vector getListaStrade() {
		return listaStrade;
	}
	
	//aggiunge una strada all'incrocio
	public void addStrada(int posizione, boolean attraversamento, boolean inversione) {		
		Strada temp = new Strada(attraversamento, inversione);
		listaStrade.insertElementAt(temp, posizione);
	}
	
	// Aggiunge pi� strade contemporaneamente
	public void addStrade(int numero, int posizioneInit, boolean arrAttraversamenti[], boolean arrInversioni[]) {
		for (int i = 0; i < numero; i++) {
			boolean attraversamento = arrAttraversamenti[i];
			boolean inversione = arrInversioni[i];
			this.addStrada(posizioneInit+i, attraversamento, inversione);
		}
	}
	
	//rimuove una strada dalla lista
	public void removeStrada(int posizione) {
		try {
			listaStrade.removeElementAt(posizione);
		}
		catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Errore nella rimozione della strada", "Errore rimozione", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	//rimuove pi� strade contemporaneamente
	public void removeStrade(int numero, int posizione) {
		for (int i = 0; i < numero; i++) {
			try {
				listaStrade.removeElementAt(posizione);
			}
			catch (Exception e) {
				JOptionPane.showMessageDialog(null, "Errore nella rimozione della strada", "Errore rimozione", JOptionPane.ERROR_MESSAGE);
			}			
		}
	}
        
        public void salvaIncrocio(String filename){
            try {
                ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(filename));
                out.writeObject(this);
                out.close();
            } catch (Exception ex) {
                System.err.println("Errore nel salvataggio del file!");
            }
        }
        
        public static void loadIncrocio(String filename){
            try {
                ObjectInputStream in = new ObjectInputStream(new FileInputStream(filename));
                instance = (Incrocio)in.readObject();
                in.close();
            } catch (Exception ex) {
                System.err.println("Errore nel caricamento del file!" + ex.toString());
            }
        }
        
	
}