package struttura;

import java.io.Serializable;
import java.util.Vector;

public class ListaFlussi implements Serializable {
	
	private Vector<Flusso> listaFlussi;
	
	private final String VARNAME_PREFIX = "f";
	
	// Costruttore
	public ListaFlussi() {
		listaFlussi = new Vector<Flusso>();
	}
	
	// METODI DI ADD DEI FLUSSI
	
	public void add(int sorgente, int destinazione) {
		Flusso flusso = new Flusso(sorgente, destinazione);
		addFlusso(flusso);
	}
	
	public void addFlusso(Flusso flusso) {
		if (listaFlussi.indexOf(flusso) == -1)
			listaFlussi.add(flusso);
	}
	
	public void addListaFlussi(ListaFlussi subListaFlussi) {
		for (int i = 0; i < subListaFlussi.size(); i++) {
			addFlusso(subListaFlussi.getFlusso(i));
		}
	}
	
	// METODI DI REMOVE DEI FLUSSI
	
	public void removeFlusso(Flusso flusso) {
		for (int i = 0; i < listaFlussi.size(); i++) {
			Flusso currentFlusso = listaFlussi.get(i);
			if (currentFlusso.getSorgente() == flusso.getSorgente() && currentFlusso.getDestinazione() == flusso.getDestinazione())
				listaFlussi.removeElement(currentFlusso);
		}
	}
	
	// METODI DI GET DEI FLUSSI
	
	public Flusso getFlusso(int index) {
		return listaFlussi.get(index);
	}
	
	public Flusso getFlussoByVarName(String varName) {
		int index = Integer.parseInt(varName.substring(VARNAME_PREFIX.length()));
		return listaFlussi.get(index);
	}
	
	public String getFlussoVarName(Flusso flusso) {
		String varName = VARNAME_PREFIX + listaFlussi.indexOf(flusso);
		return varName;
	}
	
	// ALTRI METODI
	
	// restituisce 'true' se il flusso (sorgente, destinazione) è presente in ListaFlussi, 'false' altrimenti
	public boolean contains(int sorgente, int destinazione) {
		Flusso flusso = new Flusso(sorgente, destinazione);
		if (listaFlussi.indexOf(flusso) == -1)
			return false;
		else
			return true;
	}
	
	public int getIndex(int sorgente, int destinazione) {
		Flusso flusso = new Flusso(sorgente, destinazione);
                return listaFlussi.indexOf(flusso);
	}
        
	public int size() {
		return listaFlussi.size();
	}
	
	public boolean isEmpty() {
		return listaFlussi.isEmpty();
	}
	
	// elimina i flussi presenti in 'subListaFlussi' dalla lista dei flussi
	public void subtractListaFlussi(ListaFlussi subListaFlussi) {
		for (int i = 0; i < subListaFlussi.size(); i++) {
			removeFlusso(subListaFlussi.getFlusso(i));
		}
	}
	
	public String toString() {
		String result = "{\n";
		for (int i = 0; i < listaFlussi.size(); i++) {
			if (i > 0)
				result += "\n";
			result += "\t" + getFlussoVarName(listaFlussi.get(i)) + " => " + listaFlussi.get(i).toString();
		}
		result += "\n}";
		
		return result;
	}
	
}