package struttura;

import java.io.*;
import javax.swing.*;
import java.util.Vector;

public class Strada implements Serializable {

	private Vector<Corsia> listaCorsieEntranti;
	private Vector<Corsia> listaCorsieUscenti;
	private boolean attraversamento;	// indica se un attraversamento pedonale � presente oppure no su questa strada
	private boolean inversione;	// indica se � possibile effettuare un'inversione su questa strada (ci interessa saperlo per poter spezzare i flussi)
	private int indice;	// � il numero della strada
	
	// Costruttore
	public Strada(boolean anAttraversamento, boolean anInversione) {
		listaCorsieEntranti = new Vector<Corsia>(5, 5);
		listaCorsieUscenti = new Vector<Corsia>(5, 5);
		attraversamento = anAttraversamento;
		inversione = anInversione;
	}
	
	// METODI DI SET DELLE VARIABILI
	
	public void setIndice(int anIndice) {
		indice = anIndice;
	}
	
	public void setAttraversamento(boolean anAttraversamento) {
		attraversamento = anAttraversamento;
	}
        
        public void setInversione(boolean anInversione){
            inversione = anInversione;
        }
	
	// METODI DI GET DELLE VARIABILI
	
	public int getIndice() {
		return indice;
	}
	
	public Vector getListaCorsieEntranti() {
		return listaCorsieEntranti;
	}
	
	public Vector getListaCorsieUscenti() {
		return listaCorsieUscenti;
	}
	
	public boolean getAttraversamento() {
		return attraversamento;
	}
	
	public boolean getInversione() {
		return inversione;
	}
	
	//metodi per le corsie entranti
	
	public void addCorsiaEntrante (int posizione, int tipoTraffico) {
		Corsia temp = new Corsia(Corsia.ENTRANTE, this);
		temp.addTipoTraffico(tipoTraffico);
		listaCorsieEntranti.insertElementAt(temp, posizione);
	}
	
	public void addCorsieEntranti (int numero, int posizione, int tipoTraffico[]) {
		for (int i = 0; i < numero; i++) {
			Corsia temp = new Corsia(Corsia.ENTRANTE, this);
			temp.addTipoTraffico(tipoTraffico[i]);
			listaCorsieEntranti.insertElementAt(temp, posizione+i);
		}
	}
	
	public void removeCorsiaEntrante(int posizione) {
		try {
			listaCorsieEntranti.removeElementAt(posizione);
		}
		catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Errore nella rimozione della corsia", "Errore rimozione", JOptionPane.ERROR_MESSAGE);
		}
	}
	
	public void removeCorsieEntranti(int numero, int posizione) {
		for (int i = 0; i < numero; i++) {
			try {			
				listaCorsieEntranti.removeElementAt(posizione+i);
			}
			catch (Exception e) {
				JOptionPane.showMessageDialog(null, "Errore nella rimozione della corsia", "Errore rimozione", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
	//metodi per le corsie uscenti

	public void addCorsiaUscente (int posizione, int tipoTraffico[]) {
		Corsia temp = new Corsia(Corsia.USCENTE, this);
		for (int i = 0; i < tipoTraffico.length; i++)
			temp.addTipoTraffico(tipoTraffico[i]);
		listaCorsieUscenti.insertElementAt(temp, posizione);
	}
	
	public void addCorsieUscenti (int numero, int posizione, int tipoTraffico[][]) {
		for (int i = 0; i < numero; i++) {
			Corsia temp = new Corsia(Corsia.USCENTE, this);
			for (int j = 0; j < tipoTraffico[i].length; j++)
				temp.addTipoTraffico(tipoTraffico[i][j]);
			listaCorsieUscenti.insertElementAt(temp, posizione + i);
		}
	}
	
	public void removeCorsiaUscente(int posizione) {
		try {
			listaCorsieUscenti.removeElementAt(posizione);
		}
		catch (Exception e) {
			JOptionPane.showMessageDialog(null, "Errore nella rimozione della corsia", "Errore rimozione", JOptionPane.ERROR_MESSAGE);
		}	
	}
	
	public void removeCorsieUscenti(int numero, int posizione) {
		for (int i = 0; i < numero; i++){
			try {			
				listaCorsieUscenti.removeElementAt(posizione+i);
			}
			catch (Exception e) {
				JOptionPane.showMessageDialog(null, "Errore nella rimozione della corsia", "Errore rimozione", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
}